SQLClientInfoException (Java SE 26 & JDK 26)
Description: declaration: module: java.sql, package: java.sql, class: SQLClientInfoException
Keywords: java.sql.SQLClientInfoException class

# Class SQLClientInfoException

java.lang.Object
java.lang.Throwable
java.lang.Exception
java.sql.SQLException
java.sql.SQLClientInfoException

All Implemented Interfaces:
  `Serializable, Iterable<Throwable>`

public class SQLClientInfoException extends SQLException
The subclass of `SQLException` is thrown when one or more client info properties could not be set on a `Connection`. In addition to the information provided by `SQLException`, a `SQLClientInfoException` provides a list of client info properties that were not set. Some databases do not allow multiple client info properties to be set atomically. For those databases, it is possible that some of the client info properties had been set even though the `Connection.setClientInfo` method threw an exception. An application can use the `getFailedProperties` method to retrieve a list of client info properties that were not set. The properties are identified by passing a `Map<String,ClientInfoStatus>` to the appropriate `SQLClientInfoException` constructor.

Since:
  1.6
See Also:
  - `ClientInfoStatus`
  - `Connection.setClientInfo(String, String)`
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SQLClientInfoException()`
  Constructs a `SQLClientInfoException` Object.
  `SQLClientInfoException(String reason, String SQLState, int vendorCode, Map<String, ClientInfoStatus> failedProperties)`
  Constructs a `SQLClientInfoException` object initialized with a given `reason`, `SQLState`, `vendorCode` and `failedProperties`.
  `SQLClientInfoException(String reason, String SQLState, int vendorCode, Map<String, ClientInfoStatus> failedProperties, Throwable cause)`
  Constructs a `SQLClientInfoException` object initialized with a given `reason`, `SQLState`, `cause`, `vendorCode` and `failedProperties`.
  `SQLClientInfoException(String reason, String SQLState, Map<String, ClientInfoStatus> failedProperties)`
  Constructs a `SQLClientInfoException` object initialized with a given `reason`, `SQLState` and `failedProperties`.
  `SQLClientInfoException(String reason, String SQLState, Map<String, ClientInfoStatus> failedProperties, Throwable cause)`
  Constructs a `SQLClientInfoException` object initialized with a given `reason`, `SQLState`, `cause` and `failedProperties`.
  `SQLClientInfoException(String reason, Map<String, ClientInfoStatus> failedProperties)`
  Constructs a `SQLClientInfoException` object initialized with a given `reason` and `failedProperties`.
  `SQLClientInfoException(String reason, Map<String, ClientInfoStatus> failedProperties, Throwable cause)`
  Constructs a `SQLClientInfoException` object initialized with a given `reason`, `cause` and `failedProperties`.
  `SQLClientInfoException(Map<String, ClientInfoStatus> failedProperties)`
  Constructs a `SQLClientInfoException` object initialized with a given `failedProperties`.
  `SQLClientInfoException(Map<String, ClientInfoStatus> failedProperties, Throwable cause)`
  Constructs a `SQLClientInfoException` object initialized with a given `cause` and `failedProperties`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Map<String, ClientInfoStatus>`
  `getFailedProperties()`
  Returns the list of client info properties that could not be set.

  ### Methods declared in class SQLException

  `getErrorCode, getNextException, getSQLState, iterator, setNextException`
  Modifier and Type
  Method
  Description
  `int`
  `getErrorCode()`
  Retrieves the vendor-specific exception code for this `SQLException` object.
  `SQLException`
  `getNextException()`
  Retrieves the exception chained to this `SQLException` object by setNextException(SQLException ex).
  `String`
  `getSQLState()`
  Retrieves the SQLState for this `SQLException` object.
  `Iterator<Throwable>`
  `iterator()`
  Returns an iterator over the chained SQLExceptions.
  `void`
  `setNextException(SQLException ex)`
  Adds an `SQLException` object to the end of the chain.

  ### Methods declared in class Throwable

  `addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`
  Modifier and Type
  Method
  Description
  `final void`
  `addSuppressed(Throwable exception)`
  Appends the specified exception to the exceptions that were suppressed in order to deliver this exception.
  `Throwable`
  `fillInStackTrace()`
  Fills in the execution stack trace.
  `Throwable`
  `getCause()`
  Returns the cause of this throwable or `null` if the cause is nonexistent or unknown.
  `String`
  `getLocalizedMessage()`
  Creates a localized description of this throwable.
  `String`
  `getMessage()`
  Returns the detail message string of this throwable.
  `StackTraceElement[]`
  `getStackTrace()`
  Provides programmatic access to the stack trace information printed by `Throwable.printStackTrace()`.
  `final Throwable[]`
  `getSuppressed()`
  Returns an array containing all of the exceptions that were suppressed, typically by the `try`-with-resources statement, in order to deliver this exception.
  `Throwable`
  `initCause(Throwable cause)`
  Initializes the cause of this throwable to the specified value.
  `void`
  `printStackTrace()`
  Prints this throwable and its backtrace to the standard error stream.
  `void`
  `printStackTrace(PrintStream s)`
  Prints this throwable and its backtrace to the specified print stream.
  `void`
  `printStackTrace(PrintWriter s)`
  Prints this throwable and its backtrace to the specified print writer.
  `void`
  `setStackTrace(StackTraceElement[] stackTrace)`
  Sets the stack trace elements that will be returned by `Throwable.getStackTrace()` and printed by `Throwable.printStackTrace()` and related methods.
  `String`
  `toString()`
  Returns a short description of this throwable.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

  ### Methods declared in interface Iterable

  `forEach, spliterator`
  Modifier and Type
  Method
  Description
  `default void`
  `forEach(Consumer<? super Throwable> action)`
  Performs the given action for each element of the `Iterable` until all elements have been processed or the action throws an exception.
  `default Spliterator<Throwable>`
  `spliterator()`
  Creates a `Spliterator` over the elements described by this `Iterable`.

- ## Constructor Details

  - ### SQLClientInfoException

    public SQLClientInfoException()
    Constructs a `SQLClientInfoException` Object. The `reason`, `SQLState`, and failedProperties list are initialized to `null` and the vendor code is initialized to 0. The `cause` is not initialized, and may subsequently be initialized by a call to the `Throwable.initCause(java.lang.Throwable)` method.
    Since:
      1.6

  - ### SQLClientInfoException

    public SQLClientInfoException(Map<String, ClientInfoStatus> failedProperties)
    Constructs a `SQLClientInfoException` object initialized with a given `failedProperties`. The `reason` and `SQLState` are initialized to `null` and the vendor code is initialized to 0. The `cause` is not initialized, and may subsequently be initialized by a call to the `Throwable.initCause(java.lang.Throwable)` method.
    Parameters:
      `failedProperties` - A Map containing the property values that could not be set. The keys in the Map contain the names of the client info properties that could not be set and the values contain one of the reason codes defined in `ClientInfoStatus`
    Since:
      1.6

  - ### SQLClientInfoException

    public SQLClientInfoException(Map<String, ClientInfoStatus> failedProperties, Throwable cause)
    Constructs a `SQLClientInfoException` object initialized with a given `cause` and `failedProperties`. The `reason` is initialized to `null` if `cause==null` or to `cause.toString()` if `cause!=null` and the vendor code is initialized to 0.
    Parameters:
      `failedProperties` - A Map containing the property values that could not be set. The keys in the Map contain the names of the client info properties that could not be set and the values contain one of the reason codes defined in `ClientInfoStatus`
      `cause` - the (which is saved for later retrieval by the `getCause()` method); may be null indicating the cause is non-existent or unknown.
    Since:
      1.6

  - ### SQLClientInfoException

    public SQLClientInfoException(String reason, Map<String, ClientInfoStatus> failedProperties)
    Constructs a `SQLClientInfoException` object initialized with a given `reason` and `failedProperties`. The `SQLState` is initialized to `null` and the vendor code is initialized to 0. The `cause` is not initialized, and may subsequently be initialized by a call to the `Throwable.initCause(java.lang.Throwable)` method.
    Parameters:
      `reason` - a description of the exception
      `failedProperties` - A Map containing the property values that could not be set. The keys in the Map contain the names of the client info properties that could not be set and the values contain one of the reason codes defined in `ClientInfoStatus`
    Since:
      1.6

  - ### SQLClientInfoException

    public SQLClientInfoException(String reason, Map<String, ClientInfoStatus> failedProperties, Throwable cause)
    Constructs a `SQLClientInfoException` object initialized with a given `reason`, `cause` and `failedProperties`. The `SQLState` is initialized to `null` and the vendor code is initialized to 0.
    Parameters:
      `reason` - a description of the exception
      `failedProperties` - A Map containing the property values that could not be set. The keys in the Map contain the names of the client info properties that could not be set and the values contain one of the reason codes defined in `ClientInfoStatus`
      `cause` - the underlying reason for this `SQLException` (which is saved for later retrieval by the `getCause()` method); may be null indicating the cause is non-existent or unknown.
    Since:
      1.6

  - ### SQLClientInfoException

    public SQLClientInfoException(String reason, String SQLState, Map<String, ClientInfoStatus> failedProperties)
    Constructs a `SQLClientInfoException` object initialized with a given `reason`, `SQLState` and `failedProperties`. The `cause` is not initialized, and may subsequently be initialized by a call to the `Throwable.initCause(java.lang.Throwable)` method. The vendor code is initialized to 0.
    Parameters:
      `reason` - a description of the exception
      `SQLState` - an XOPEN or SQL:2003 code identifying the exception
      `failedProperties` - A Map containing the property values that could not be set. The keys in the Map contain the names of the client info properties that could not be set and the values contain one of the reason codes defined in `ClientInfoStatus`
    Since:
      1.6

  - ### SQLClientInfoException

    public SQLClientInfoException(String reason, String SQLState, Map<String, ClientInfoStatus> failedProperties, Throwable cause)
    Constructs a `SQLClientInfoException` object initialized with a given `reason`, `SQLState`, `cause` and `failedProperties`. The vendor code is initialized to 0.
    Parameters:
      `reason` - a description of the exception
      `SQLState` - an XOPEN or SQL:2003 code identifying the exception
      `failedProperties` - A Map containing the property values that could not be set. The keys in the Map contain the names of the client info properties that could not be set and the values contain one of the reason codes defined in `ClientInfoStatus`
      `cause` - the underlying reason for this `SQLException` (which is saved for later retrieval by the `getCause()` method); may be null indicating the cause is non-existent or unknown.
    Since:
      1.6

  - ### SQLClientInfoException

    public SQLClientInfoException(String reason, String SQLState, int vendorCode, Map<String, ClientInfoStatus> failedProperties)
    Constructs a `SQLClientInfoException` object initialized with a given `reason`, `SQLState`, `vendorCode` and `failedProperties`. The `cause` is not initialized, and may subsequently be initialized by a call to the `Throwable.initCause(java.lang.Throwable)` method.
    Parameters:
      `reason` - a description of the exception
      `SQLState` - an XOPEN or SQL:2003 code identifying the exception
      `vendorCode` - a database vendor-specific exception code
      `failedProperties` - A Map containing the property values that could not be set. The keys in the Map contain the names of the client info properties that could not be set and the values contain one of the reason codes defined in `ClientInfoStatus`
    Since:
      1.6

  - ### SQLClientInfoException

    public SQLClientInfoException(String reason, String SQLState, int vendorCode, Map<String, ClientInfoStatus> failedProperties, Throwable cause)
    Constructs a `SQLClientInfoException` object initialized with a given `reason`, `SQLState`, `cause`, `vendorCode` and `failedProperties`.
    Parameters:
      `reason` - a description of the exception
      `SQLState` - an XOPEN or SQL:2003 code identifying the exception
      `vendorCode` - a database vendor-specific exception code
      `failedProperties` - A Map containing the property values that could not be set. The keys in the Map contain the names of the client info properties that could not be set and the values contain one of the reason codes defined in `ClientInfoStatus`
      `cause` - the underlying reason for this `SQLException` (which is saved for later retrieval by the `getCause()` method); may be null indicating the cause is non-existent or unknown.
    Since:
      1.6

- ## Method Details

  - ### getFailedProperties

    public Map<String, ClientInfoStatus> getFailedProperties()
    Returns the list of client info properties that could not be set. The keys in the Map contain the names of the client info properties that could not be set and the values contain one of the reason codes defined in `ClientInfoStatus`
    Returns:
      Map list containing the client info properties that could not be set
    Since:
      1.6